module Control.Category.Printf.Text.Strict
       ( module Control.Category.Printf
       , printf
       , printfLn
       , hPrintf
       , hPrintfLn
       ) where

import Prelude hiding (id, (.))
import Control.Comonad
import Control.Category.Printf
import Data.Text (Text)
import qualified Data.Text.IO as T
import System.IO (Handle)

printf :: Format Text (IO ()) b -> b
printf = printfWith T.putStr

printfLn :: Format Text (IO ()) b -> b
printfLn = printfWith T.putStrLn 

hPrintf :: Handle -> Format Text (IO ()) b -> b
hPrintf h = printfWith (T.hPutStr h)

hPrintfLn :: Handle -> Format Text (IO ()) b -> b
hPrintfLn h = printfWith (T.hPutStrLn h)
